From 73b22419edd563cf26bc8688c3f04fb3cf414cb0 Mon Sep 17 00:00:00 2001
From: Frederic Cambus <fred@statdns.com>
Date: Thu, 28 Sep 2023 13:39:01 +0100
Subject: [PATCH] Add support to readelf for the PT_OPENBSD_NOBTCFI segment
 type.

---
 binutils/ChangeLog   | 5 +++++
 binutils/readelf.c   | 1 +
 include/ChangeLog    | 4 ++++
 include/elf/common.h | 1 +
 4 files changed, 11 insertions(+)

diff --git a/binutils/ChangeLog b/binutils/ChangeLog
index 88f8373fca8..07194aae3db 100644
--- a/binutils/ChangeLog
+++ b/binutils/ChangeLog
@@ -1,3 +1,8 @@
+2023-09-28  Frederic Cambus  <fred@statdns.com>
+
+	* readelf.c (get_segment_type): Handle PT_OPENBSD_NOBTCFI segment
+	type.
+
 2023-09-26  Nick Clifton  <nickc@redhat.com>
 
 	* testsuite/binutils-all/ar.exp: Remove assumption of the setting
diff --git a/binutils/readelf.c b/binutils/readelf.c
index e9935c010cf..be2f3851c63 100644
--- a/binutils/readelf.c
+++ b/binutils/readelf.c
@@ -5082,6 +5082,7 @@ get_segment_type (Filedata * filedata, unsigned long p_type)
     case PT_OPENBSD_MUTABLE: return "OPENBSD_MUTABLE";
     case PT_OPENBSD_RANDOMIZE: return "OPENBSD_RANDOMIZE";
     case PT_OPENBSD_WXNEEDED: return "OPENBSD_WXNEEDED";
+    case PT_OPENBSD_NOBTCFI: return "OPENBSD_NOBTCFI";
     case PT_OPENBSD_BOOTDATA: return "OPENBSD_BOOTDATA";
 
     default:
diff --git a/include/ChangeLog b/include/ChangeLog
index eb54da44146..90ee73650c3 100644
--- a/include/ChangeLog
+++ b/include/ChangeLog
@@ -1,3 +1,7 @@
+2023-09-28  Frederic Cambus  <fred@statdns.com>
+
+	* elf/common.h (PT_OPENBSD_NOBTCFI): Define.
+
 2023-08-02  Tom Tromey  <tromey@adacore.com>
 
 	* coff/x86_64.h (COFF_X86_64_H): Add include guard.
diff --git a/include/elf/common.h b/include/elf/common.h
index 932ea94e3ae..2edfb15efc7 100644
--- a/include/elf/common.h
+++ b/include/elf/common.h
@@ -495,6 +495,7 @@
 #define PT_OPENBSD_MUTABLE   (PT_LOOS + 0x5a3dbe5)  /* Like bss, but not immutable.  */
 #define PT_OPENBSD_RANDOMIZE (PT_LOOS + 0x5a3dbe6)  /* Fill with random data.  */
 #define PT_OPENBSD_WXNEEDED  (PT_LOOS + 0x5a3dbe7)  /* Program does W^X violations.  */
+#define PT_OPENBSD_NOBTCFI   (PT_LOOS + 0x5a3dbe8)  /* No branch target CFI.  */
 #define PT_OPENBSD_BOOTDATA  (PT_LOOS + 0x5a41be6)  /* Section for boot arguments.  */
 
 /* Mbind segments */
-- 
2.41.0

